--This script was created by Gizmo for public use for the
--Legends of Aria community. Thank you for using my system.

--=============
--version 1.3
--=============
--cleaned up some of the code
--added a new create it button
--added edit loot template event handler
--added sequential spawn objvars
--	current_sequence 0 
--	sequential {true/false}
--  group_spawn {true/false}
--  kill_count 0
--added sequence check to Spawn function
--added Command Functions handled in HandleChanges function
--added a few dozen in game commands to work with your spawners
--and how they interact in the world.

-- bug fixes
-- when a spawner was set to 0 min and 0 max delay it would spawn a 
-- zillion of the monster. I have it catching this delay and it can
-- never be below 0.1 or 1/10th a second. this fixes the bug for now
-- thank you brother brother from LoU for this information.

--=============
--version 1.2
--=============
--  added 3 new event handlers for
--  "Respawn" message
--  "Sleep" message
--  "Wakeup" message
--  added onLoaded Event Handler
--  added new function UpdateSpawner
--
--	when the spawner recieves the "Sleep" message it despawns
--  everything and stores there templates in the reset_list
--  table. When it spawns it just spawns a template id in the
--  reset_list instead of the real thing. it will continue
--  to spawn objects till it reaches count_max.
--
--  when the spawner recieves the "Wakeup" message it will
--  grab the reset_list and respawn all of it back to the
--  the world.
--
--  when the spawne recieves the "Respawn" message it will
--  remove all active spawns, clear the mob_list, then it
--  will spawn up to count_max.

--=============
--version 1.1
--=============
--	in the EventType.Message, "mobHasDied" I removed
--	the mobile being passed it wasnt needed. i also
-- 	added a check to see if its a mobile so it can
--	process the loot.
--
--	added checks in the EventType.CreatedObject, "mobileSpawned",
--  i cleaned up this event call to remove the attachments of
--  modules that didn't need to be attached and where out dated.

require 'gizmos_simple_spawner.gizmos_spawner_edit_window'
require 'gizmos_simple_spawner.gizmos_spawner_tooltip'
require 'gizmos_simple_spawner.gizmos_spawner_tables'
require 'gizmos_simple_spawner.gizmos_spawner_hue_picker'


local COMMAND_KEY = "@"
--=====================================================================
--							CORE FUNCTIONS
--=====================================================================

function getIf(mBool, v1, v2)
    if mBool then 
        return v1
    else
        return v2
    end
end


-----------------------------------------------------------------------
--					HandleChanges(mob,spawn_template)	  	
-----------------------------------------------------------------------
-- version 1.3
-- handles the simple scripting language entries for
-- the spawned object. some entries will not work on
-- some objects but I wont be doing checking for that
function HandleChanges(mob,spawn_template)
	if(spawn_template == nil) then return end

	local dataTable = StringSplit(spawn_template,COMMAND_KEY)
	for i=1 , #dataTable do
		--first value is always the mob template, rest is code
		if(i > 1) then
			local todo = StringSplit(dataTable[i],":")
			if(todo[1] == "hue") then mob:SetHue(todo[2]) end
			if(todo[1] == "scale") then mob:SetScale(Loc(tonumber(todo[2]),tonumber(todo[2]),tonumber(todo[2]))) end
			if(todo[1] == "str") then CallFunctionDelayed(TimeSpan.FromMilliseconds(250),function ( ... ) SetStr(mob,tonumber(todo[2])) end) end
			if(todo[1] == "agi") then CallFunctionDelayed(TimeSpan.FromMilliseconds(250),function ( ... ) SetAgi(mob,tonumber(todo[2])) end) end
			if(todo[1] == "int") then CallFunctionDelayed(TimeSpan.FromMilliseconds(250),function ( ... ) SetInt(mob,tonumber(todo[2])) end) end
			if(todo[1] == "con") then CallFunctionDelayed(TimeSpan.FromMilliseconds(250),function ( ... ) SetWis(mob,tonumber(todo[2])) end) end
			if(todo[1] == "wis") then CallFunctionDelayed(TimeSpan.FromMilliseconds(250),function ( ... ) SetCon(mob,tonumber(todo[2])) end) end
			if(todo[1] == "will") then CallFunctionDelayed(TimeSpan.FromMilliseconds(250),function ( ... ) SetWill(mob,tonumber(todo[2])) end) end
			if(todo[1] == "name") then mob:SetName(todo[2]) end
			if(todo[1] == "title") then CallFunctionDelayed(TimeSpan.FromMilliseconds(25),function ( ... ) mob:SetSharedObjectProperty("Title", todo[2]) end) end
			if(todo[1] == "team") then 
				CallFunctionDelayed(TimeSpan.FromMilliseconds(25), 
				function ( ... ) 
					mob:SetObjVar("MobileTeamType",todo[2])
					mob:SetSharedObjectProperty("Faction", todo[2]) 
				end) 
			end
		end
	end
end

function NextSequence()
	local current_sequence = this:GetObjVar("current_sequence")
	local max_sequence = #this:GetObjVar("templates")
	current_sequence = current_sequence + 1
	if(current_sequence > max_sequence) then
		current_sequence = 1
	end
	this:SetObjVar("current_sequence",current_sequence)
end

-----------------------------------------------------------------------
--					CheckingCommands(data)		  	
-----------------------------------------------------------------------
-- version 1.3
-- this runs scripting commands that effect spawners, and other objects
-- so the spawner can communicate and change objects data.
function CheckingCommands(data)
	if(data[1] == "THIS") then
		if(data[2] == "ShutDown()") then 
			ShutDown()
			return true
		end 
	end
	local target = nil
	if(data[1] == "OBJECT") then
		if (data[3] == "SendMessage()") then
			if(data[2]=="SELF") then
				target = this
			else
				target = GameObj(tonumber(data[2]))
			end
			local message = data[4]
			if(target ~= nil) then
				--print("Sending Message To Object#"..target.Id .. ":" .. target:GetName() .. " - Message ="..message)
				if(message == "deactivate" and data[2]=="SELF") then
					ShutDown()
					return true
				end
				target:SendMessage(message)
				if(message=="deactivate") then
					if(data[2] ~= "SELF") then 
						NextSequence()
						return true
					end
				end
			end
			NextSequence()
			return true
		end
		if(data[3] == "SetHue()") then
			if(data[2] == "SELF") then
				target = this
			else
				target = GameObj(tonumber(data[2]))
			end
			local hue = data[4]
			if(target ~= nil) then
				--print("Setting Hue of Object#"..target.Id .. ":" .. target:GetName() .. " - Hue ="..hue)
				target:SetHue(hue)			
			end
			NextSequence()
			return true
		end
		return false
	end
end

-----------------------------------------------------------------------
--			 			SequentialSpawnObject()			  	
-----------------------------------------------------------------------
-- version 1.3
--this is the spawn cycle for the sequential spawn system
function SequentialSpawnObject()
	local sleeping = this:GetObjVar("sleeping")
	--are we sleeping?
	if not(sleeping) then
		if(this:HasObjVar("PhaseSpawned")) then return end

		local templates = this:GetObjVar("templates")
		local min_range = this:GetObjVar("min_range")
		local max_range = this:GetObjVar("max_range")
		local count_max = this:GetObjVar("count_max")
		local spawn_mobile = ""
		local spawn_template = templates[this:GetObjVar("current_sequence")]
		
		local data = StringSplit(spawn_template,COMMAND_KEY)

		if(CheckingCommands(data) == true) then 
			return true 
		end

		local spawn_mobile = data[1]
		local amount_to_spawn = this:GetObjVar("count_max")

		for i=1, amount_to_spawn do
			CreateObj(spawn_mobile,this:GetLoc():Project(math.random(0,360), math.random(min_range,max_range)),"mobileSpawned",1,spawn_template)						
		end
		this:SetObjVar("PhaseSpawned",true)
	end
end

-----------------------------------------------------------------------
--						  	SpawnObject
-----------------------------------------------------------------------
--this will spawn an mobile from the templates list
function SpawnObject()
	if(this:GetObjVar("templates") ~= nil) then

		--if we are sequantial then run the sequence
		--then return back because the below code
		--don't mean anything
		--version 1.3

		--if(SequentialCheck()) then return end

		local templates = this:GetObjVar("templates")
		local min_range = this:GetObjVar("min_range")
		local max_range = this:GetObjVar("max_range")
		local count_max = this:GetObjVar("count_max")
		local spawn_mobile = ""
		local spawn_template = templates[math.random(1,#templates)]
		
		local data = StringSplit(spawn_template,COMMAND_KEY)
		local spawn_mobile = data[1]

		--version 1.3
		if(CheckingCommands(data) == true) then
			return nil
		end
		--repopulate the spawner virtually
		if(this:GetObjVar("sleeping") == true) then
			local reset_list = this:GetObjVar("reset_list") or {}
			if(reset_list ~= nil and (#reset_list < count_max)) then
				table.insert(reset_list,spawn_mobile)
				this:SetObjVar("reset_list",reset_list)

				local current_count = this:GetObjVar("count_current")
				current_count = current_count + 1
				this:SetObjVar("count_current",current_count)				
				UpdateToolTip(this,false)
			end
			return
		end

		if(type(templates) == "table") then
			CreateObj(spawn_mobile,this:GetLoc():Project(math.random(0,360), math.random(min_range,max_range)),"mobileSpawned",1,spawn_template)
		end
	else
		print("Spawner Respawn Error")
		print("Spawner Name: "..this:GetName())
		print("Spawner Id: "..this.Id)
		print("Attempting to Spawn: "..this:GetObjVar("templates"))
	end
end

-----------------------------------------------------------------------
--						  On Module Attached
-----------------------------------------------------------------------
--when this module is attached this will set up various values for
--the spawner system
function OnModuleAttached()
	--set up the basic variables
	local templates = {}
	this:SetObjVar("templates",templates)

	this:SetObjVar("mob_list",{})
	--setup search feature variables
 -- {Mobile,Item,Other}
	this:SetObjVar("sleeping",false)
	--tables for the spawner
	--all tables are located in gizmos_spawner_tables
	this:SetObjVar("config",ConfigurationData)
	this:SetObjVar("loot",LootData)

	--version 1.2 
	--this is for new spawners
	this:SetObjVar("sleeping",false)
	this:SetObjVar("reset_list",{})

	--version 1.3
	--initialization
	if(initializer ~= nil) then
		if(initializer.Loot ~= nil) then
			local lootList = {}
			--local loot_table = {data[1],data[2],data[3]}
			for i, lootItem in pairs(initializer.Loot) do
				local loot = {lootItem["Template"],lootItem["Chance"],lootItem["Amount"]}
				table.insert(lootList,loot)
			end
			this:SetObjVar("loot",lootList)
		end
		if(initializer.Templates ~= nil) then
			local templates = {}
			for i, template in pairs(initializer.Templates) do
				table.insert(templates,template)
			end
			this:SetObjVar("templates",templates)
		end
		--initialize config
		local min_delay = this:GetObjVar("min_delay")
		local max_delay = this:GetObjVar("max_delay")
		local min_range = this:GetObjVar("min_range")
		local max_range = this:GetObjVar("max_range")
		local count_max = this:GetObjVar("count_max")
		local spawner_tag = this:GetObjVar("spawner_tag")

		local data =
		{
			{"min_delay", min_delay},
			{"max_delay", max_delay},
			{"min_range", min_range},
			{"max_range", max_range},
			{"count_max", count_max},
			{"spawner_tag", spawner_tag},
		}
		this:SetObjVar("config",data)

		this:SetObjVar("current_sequence",1)
		this:SetObjVar("sequential",false)
		--this:SetObjVar("group_spawn",false)
		this:SetObjVar("kill_count",0)		
	end
end

-----------------------------------------------------------------------
--						  	Update Config
-----------------------------------------------------------------------
--when the update button is clicked on the Config tab it will update
--all the values on the spawners objvars.
function UpdateConfig()
	local config = 
	{
		{"min_delay", this:GetObjVar("min_delay")},
		{"max_delay", this:GetObjVar("max_delay")},
		{"min_range", this:GetObjVar("min_range")},
		{"max_range", this:GetObjVar("max_range")},
		{"count_max", this:GetObjVar("count_max")},
		{"spawner_tag", this:GetObjVar("spawner_tag")},
	}
	this:SetObjVar("config",config)
end

-----------------------------------------------------------------------
--						    Despawn Object
-----------------------------------------------------------------------
--when this is called it will despawn everything that is currently
--active from this spawner
function ShutDown()
	this:SetObjVar("active",false)
	local mob_list = this:GetObjVar("mob_list")
	if(#mob_list > 0) then
		for i=#mob_list, 1, -1 do
			local object = GameObj(tonumber(mob_list[i]))
			object:Destroy()
		end
	end
	this:SetObjVar("mob_list",{})
	this:SetObjVar("reset_list",{})
	this:SetObjVar("count_current", 0)
	this:DelObjVar("PhaseSpawned")
 	this:SetObjVar("kill_count",0)
 	this:SetObjVar("current_sequence",1)
	if(this:HasTimer("spawnerTimer")) then this:RemoveTimer("spawnerTimer") end
end

-----------------------------------------------------------------------
--						  Get Respawn Delay
-----------------------------------------------------------------------
--this sets the respawn delay for the next mobile respawn time. this 
--value is determined from a math.random(min_delay,max_delay)
function GetRespawnDelay()
	local min_delay = this:GetObjVar("min_delay")
	local max_delay = this:GetObjVar("max_delay")
	if(max_delay < min_delay) then
		ShutDown()
	end
	local time_delay = math.random(min_delay,max_delay)
	if(time_delay <= 0) then time_delay = 0.1 end
	return time_delay
end

-----------------------------------------------------------------------
--					    Create Loot On Mobile
-----------------------------------------------------------------------
function CreateLootOnMobile(mobile)
	local backpackObj = mobile:GetEquippedObject("Backpack")
	if(#this:GetObjVar("loot") ~= 0) then
		local lootTemplate = this:GetObjVar("loot")[math.random(1,#this:GetObjVar("loot"))]	
		local itemTemplate = lootTemplate[1]
		local itemChance = lootTemplate[2]
		local itemQuantity = lootTemplate[3]

		if(tonumber(itemQuantity) > 1) then
			if(math.random(1,itemChance)==1) then
				CreateObjInContainer(itemTemplate, backpackObj, GetRandomDropPosition(backpackObj), "createdStackableLootOnMobile", tonumber(itemQuantity))
			end
		else
			if(math.random(1,itemChance)==1) then
				CreateObjInContainer(itemTemplate, backpackObj, GetRandomDropPosition(backpackObj), "createdLootOnMobile")
			end
		end
	end
end

-----------------------------------------------------------------------
--					    Spawner Update
-----------------------------------------------------------------------
--this controls updated items that need to be active when the spawner
--code kicks in for the first time on older spawners. 
function SpawnerUpdate()
	--version 1.2
	--holds the template data for the sleep mode monsters
	if not (this:HasObjVar("reset_list")) then
		this:SetObjVar("reset_list",{})
	end
	--tells the spawner to sleep [true/false]
	if not(this:HasObjVar("sleeping")) then
		this:SetObjVar("sleeping",false)
	end
	--version 1.3
	--if set to true will turn spawner to
	--sequential spawning mode
	if not(this:HasObjVar("sequential")) then
		this:SetObjVar("sequential",false)
	end
	--if set to true, the spawner will spawn max 
	--spawn instead of 1 at a time.. this only
	--works with sequential spawning
	--if not(this:HasObjVar("group_spawn")) then
	--	this:SetObjVar("group_spawn",false)
	--end
	--everytime a item/monster is destroyed/pickedup it will
	--add one to killcount. if killcount = totalkillcount
	--then the spawner will add one to the currentsequence
	if not(this:HasObjVar("kill_count")) then
		this:SetObjVar("kill_count",0)
	end
	--this keeps track of the current sequence of the
	--sequential spawning system. the sequence will not be
	--updated unless the total_kill_count has been reached
	if not(this:HasObjVar("current_sequence")) then
		this:SetObjVar("current_sequence",1)
	end	

	--i fixed the capitalization of the objvar "Sleeping" to
	--"sleeping"
	local sleeping = nil
	if(this:HasObjVar("Sleeping")) then
		sleeping = this:GetObjVar("Sleeping")
		this:DelObjVar("Sleeping")
		this:SetObjVar("sleeping",sleeping)
	end

	--make sure the timer starts correctly
	if(this:GetObjVar("active") == true) then
		this:ScheduleTimerDelay(TimeSpan.FromSeconds(GetRespawnDelay()), "spawnerTimer")
	else
		this:RemoveTimer("spawnerTimer")
	end
end

function CreateTemplate(fullpath,user)
	print("--------------------------------------------------------------------------")
	print("     Exporting a spawner object created by Gizmos Simple Spawner System    ")
	print("--------------------------------------------------------------------------")

	local file = io.open(fullpath,"w")

	print("Writing file -> "..fullpath)
	print("Writing Spawner Configurations...")
	file:write("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n")
	file:write("<ObjectTemplate xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">\n")
	file:write("\t<ClientId>2</ClientId>\n")
	file:write("\t<Hue>" .. this:GetHue() .. "</Hue>\n")
	file:write("\t<Name>" .. this:GetName() .. "</Name>\n")
	
	file:write("\t<ObjectVariableComponent>\n")
		file:write("\t\t<StringVariable Name=\"Gizmos_Search_Function\">Don't Change This</StringVariable>\n")
		file:write("\t\t<StringVariable Name=\"templates\">empty</StringVariable>\n")
		file:write("\t\t<DoubleVariable Name=\"min_delay\">" .. this:GetObjVar("min_delay") .. "</DoubleVariable>\n")
		file:write("\t\t<DoubleVariable Name=\"max_delay\">" .. this:GetObjVar("max_delay") .. "</DoubleVariable>\n")
		file:write("\t\t<DoubleVariable Name=\"min_range\">" .. this:GetObjVar("min_range") .. "</DoubleVariable>\n")
		file:write("\t\t<DoubleVariable Name=\"max_range\">" .. this:GetObjVar("max_range") .. "</DoubleVariable>\n")
		file:write("\t\t<DoubleVariable Name=\"count_current\">0</DoubleVariable>\n")
		file:write("\t\t<DoubleVariable Name=\"count_max\">" .. this:GetObjVar("count_max") .. "</DoubleVariable>\n")
		file:write("\t\t<StringVariable Name=\"NoReset\">true</StringVariable>\n")
		file:write("\t\t<StringVariable Name=\"active\">false</StringVariable>\n")
		file:write("\t\t<StringVariable Name=\"spawner_tag\">" .. this:GetObjVar("spawner_tag") .. "</StringVariable>\n")
		file:write("\t\t<StringVariable Name=\"mob_list\">empty</StringVariable>\n")
		file:write("\t\t<StringVariable Name=\"config\">empty</StringVariable>\n")
		file:write("\t\t<StringVariable Name=\"loot\">empty</StringVariable>\n")
		file:write("\t\t<StringVariable Name=\"current_sequence\">1</StringVariable>\n")
		file:write("\t\t<StringVariable Name=\"kill_count\">0</StringVariable>\n")
		file:write("\t\t<BoolVariable Name=\"sequential\">" .. getIf(this:GetObjVar("sequential"),"true","false") .. "</BoolVariable>\n")
		file:write("\t\t<BoolVariable Name=\"sleeping\">false</BoolVariable>\n")
	file:write("\t</ObjectVariableComponent>\n")
	
	file:write("\t<ScriptEngineComponent>\n")
		file:write("\t\t<LuaModule Name=\"gizmos_simple_spawner.gizmos_simple_spawner\">\n")
			file:write("\t\t\t<Initializer>\n")
			file:write("\t\t\t{\n")
				WriteLootItems(file)
				WriteTemplateList(file)
	        file:write("\t\t\t}\n")
			file:write("\t\t\t</Initializer>\n")
		file:write("\t\t</LuaModule>\n")
	file:write("\t</ScriptEngineComponent>\n")
	file:write("</ObjectTemplate>")
	file:close()
	print("--------------------------------------------------------------------------")
	print("     Template Completed, thank you for using Gizmos Simple Spawner      ")
	print("--------------------------------------------------------------------------")
	user:SystemMessage("[FF7700]"..fullpath.."[FFFFBB]... scripted and saved!")
end


function tablelength(table)
	local count = 0
	for _ in pairs(table) do count = count + 1 end
	return count
end

function WriteLootItems(file)
	if(tablelength(this:GetObjVar("loot")) <= 0) then return end
	print("Writing Loot Information....")
	file:write("\t\t\t\tLoot =\n")
	file:write("\t\t\t\t{\n")
	for i,lootlist in pairs(this:GetObjVar("loot")) do
		file:write("\t\t\t\t\t{\n")
		file:write("\t\t\t\t\t\tTemplate=\"" .. lootlist[1] .. "\",\n")
		file:write("\t\t\t\t\t\tChance=\"" .. lootlist[2] .. "\",\n")
		file:write("\t\t\t\t\t\tAmount=\"" .. lootlist[3] .. "\",\n")
		file:write("\t\t\t\t\t},\n")
	end
	file:write("\t\t\t\t},\n")
end

function WriteTemplateList(file)
	if(tablelength(this:GetObjVar("templates")) <= 0) then return end
	print("Writing Template information...")
	file:write("\t\t\t\tTemplates =\n")
	file:write("\t\t\t\t{\n")
	for i,template in pairs(this:GetObjVar("templates")) do
		file:write("\t\t\t\t\t\""..template.."\",\n")
	end
	file:write("\t\t\t\t},\n")
end

--======================================================================
--							EVENT HANDLERS
--======================================================================
----------------------------------------------------------
--EVENTTYPE - ModuleAttached
----------------------------------------------------------
--fire up OnModuleAttached, should only be firing when the 
--gizmo_simple_spawner object is spawned. Though this could be
--attached to about anything and probably run okay. 
RegisterSingleEventHandler(EventType.ModuleAttached, GetCurrentModule(), 
	function()
		OnModuleAttached()
		UpdateToolTip(this,false)
		AddUseCase(this,"Hue",false)
		AddUseCase(this,"Edit",true)
		AddUseCase(this,"Move",false)
		AddUseCase(this,"Duplicate",false)
	end)

----------------------------------------------------------
-- EVENTTYPE - Message - "UseObject"
----------------------------------------------------------
-- when you click the spawner in game, it will open up the
-- edit menu for you. you can also can use another option
-- by right clicking the spawner and selecting "Edit"
RegisterEventHandler(EventType.Message, "UseObject", 
    function(user,usedType)
        if(usedType == "Hue") then
        	user:CloseDynamicWindow("EditHueDialog")
        	SimpleSpawnerHuePicker(user,this)
        end    	
        if(usedType == "Edit") then 
        	user:CloseDynamicWindow("EditSpawnerDialog")
        	SimpleSpawnerEditWindow(user,this,"Config")
        	UpdateToolTip(this,true) 
        end
        if(usedType == "Move") then
        	user:RequestClientTargetLoc(this,"moveToTarget")
        	user:SystemMessage("select a location to move this spawner too")
        end
        if(usedType == "Duplicate") then
        	user:RequestClientTargetLoc(this,"duplicateAtTarget")
        	user:SystemMessage("select a location you wish to place a copy of this spawner at")
        end       
    end)

----------------------------------------------------------
-- EVENTTYPE - ClientTargetLocResponse - "moveToTarget"
----------------------------------------------------------
--on the context menu when you choose Move this will be fired
--and move the spawner to the selected location
RegisterEventHandler(EventType.ClientTargetLocResponse,"moveToTarget",
	function(success,location)
		if(success and location ~= nil) then
			this:PlayEffect("TeleportToEffect")
			this:SetWorldPosition(location)
			this:PlayEffect("TeleportFromEffect")
		end
	end)

----------------------------------------------------------
-- EVENTTYPE - ClientTargetLocResponse - "duplicateAtTarget"
----------------------------------------------------------
--on the context menu when you choose Move this will be fired
--and move the spawner to the selected location
RegisterEventHandler(EventType.ClientTargetLocResponse,"duplicateAtTarget",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("gizmos_simple_spawner",location,"duplicateCreated")
		end
	end)

----------------------------------------------------------
--EVENTTYPE - CreatedObject - "duplicateCreated"
----------------------------------------------------------
--when you create a duplicate of the spawner this will
--copy all the data over to the new spawner
--there is a 1 second delay before the data gets put on
--the duplicated spawner
RegisterEventHandler(EventType.CreatedObject, "duplicateCreated", 
	function(success, objref, index)
		if( success) then
			CallFunctionDelayed(TimeSpan.FromSeconds(1),function ( ... )
				objref:SetHue(this:GetHue())
				objref:SetName(this:GetName())
				objref:SetObjVar("templates",this:GetObjVar("templates"))
				objref:SetObjVar("min_delay",this:GetObjVar("min_delay"))
				objref:SetObjVar("max_delay",this:GetObjVar("max_delay"))
				objref:SetObjVar("min_range",this:GetObjVar("min_range"))
				objref:SetObjVar("max_range",this:GetObjVar("max_range"))
				objref:SetObjVar("count_max",this:GetObjVar("count_max"))
				objref:SetObjVar("spawner_tag",this:GetObjVar("spawner_tag"))
				objref:SetObjVar("config",this:GetObjVar("config"))
				objref:SetObjVar("loot",this:GetObjVar("loot"))
				objref:SetObjVar("current_sequence",0)
				objref:SetObjVar("kill_count",0)
				objref:SetObjVar("sequential",this:GetObjVar("sequential"))
				UpdateToolTip(objref,false)
			end)
		end
	end)

----------------------------------------------------------
--EVENTTYPE - Message - "mobHasDied"
----------------------------------------------------------
--this message is sent from the base_mobile.lua file
--You can put the following into the DoMobileDeath(damager) function
--
--	if(this:HasObjVar("parentSpawner")) then
--		this:SendMessage("mobHasDied", damager,this)
--	end
--
-- you could place this near any of the SendMessage calls and it should
-- be fine.

--version 1.3
--this event handler took a huge overhaul in how it works
--it corrected some bugs and timing issues
RegisterEventHandler(EventType.Message, "mobHasDied", 
    function(deadmob)
    	print("I DIED!")
    	if(this:GetObjVar("active")) then
			local mob_list = this:GetObjVar("mob_list")

	    	if(this:GetObjVar("sequential")) then
 				local kill_count = this:GetObjVar("kill_count")
 				kill_count = kill_count + 1
 				if(deadmob:HasObjVar("is_spawner_boss")) then kill_count = this:GetObjVar("count_max") end
 				if(kill_count >= this:GetObjVar("count_max")) then
 					print("thats all folks")
 					local current_sequence = this:GetObjVar("current_sequence")
 					print("current_sequence = "..current_sequence)
 					this:DelObjVar("PhaseSpawned")
 					current_sequence = current_sequence + 1
 					if(current_sequence > #this:GetObjVar("templates")) then
 						current_sequence = 1
 						kill_count = 0
 					else
 						kill_count = 0
 					end
 					this:SetObjVar("count_current",0)
 					this:SetObjVar("current_sequence",current_sequence)
 					print("updated... current_sequence"..current_sequence)
 				else
 					--for debug later
 				end
 				this:SetObjVar("kill_count",kill_count)
    		else
	    		local current_count = this:GetObjVar("count_current")
	    		local current_count = current_count - 1

	    		-- make sure current_count isn't less then zero
	    		if(current_count <= 0) then current_count = 0 end	
	    		this:SetObjVar("count_current",current_count)
	    	end	
    		--remove the mob from the mob_list objvar
    		for i=1, #mob_list do
    			if(mob_list[i] == deadmob.Id) then
    				table.remove(mob_list,i)
    				this:SetObjVar("mob_list",mob_list)
    			end
    		end

    		--create loot if needed
    		if(deadmob:IsMobile()) then
    			CreateLootOnMobile(deadmob) 
    		end
    		UpdateToolTip(this,false)
    	end
    end)

----------------------------------------------------------
--EVENTTYPE - Message - "Sleep"
----------------------------------------------------------
--added in version 1.2
--this handles the sleep message
RegisterEventHandler(EventType.Message, "Sleep", 
    function()
    	if(this:GetObjVar("sequential")==true) then
    		print("I dont sleep during sequential spawns sorry.")
    		return
    	end
    	if not(this:GetObjVar("sleeping")) then
    	local mob_list = this:GetObjVar("mob_list")
    	local reset_list = {}
    	for i,val in pairs(mob_list) do
    		local obj = GameObj(tonumber(val))
    		if(obj ~= nil) then
    			table.insert(reset_list,obj:GetCreationTemplateId())
    			obj:Destroy()
    		end
    	end
    	this:SetObjVar("reset_list",reset_list)
    	this:SetObjVar("sleeping",true)
    	UpdateToolTip(this,false)
    	else
    		print("Something is trying to put me to sleep, but im already sleeping - [SpawnerID#"..this.Id.."]")
    	end
    end)

----------------------------------------------------------
--EVENTTYPE - Message - "Wakeup"
----------------------------------------------------------
--added in version 1.2
--this handles the wakeup message
RegisterEventHandler(EventType.Message, "Wakeup", 
    function()
    	if(this:GetObjVar("sequential")==true) then
    		print("I cant sleep so obviously I am awake.")
    		return
    	end    	
    	if(this:GetObjVar("sleeping")) then
	    	local reset_list = this:GetObjVar("reset_list")
	    	local min_range = this:GetObjVar("min_range")
	    	local max_range = this:GetObjVar("max_range")
	    	local templates = this:GetObjVar("templates")
	    	this:SetObjVar("mob_list",{})
	    	local spawn_mobile = ""
			local spawn_template = templates[this:GetObjVar("current_sequence")]
			local data = StringSplit(spawn_template,COMMAND_KEY)
			local spawn_mobile = data[1]

	    	if(reset_list ~= nil) then
	    		for i,template in pairs(reset_list) do
	    			CreateObj(data[1],this:GetLoc():Project(math.random(0,360), math.random(min_range,max_range)),"mobileSpawned",1,spawn_template)
	    		end
	    	else
	    		print("Gizmos Spawning System Error: ObjVar 'reset_list' is nil : in EventType.Message \"Wakeup\"")
	    	end



	    	this:SetObjVar("count_current",#this:GetObjVar("mob_list"))
    		this:SetObjVar("sleeping",false)
    		UpdateToolTip(this,false)
    	else
    		print("Something is trying to wake me up, but im awake - [SpawnerID#"..this.Id.."]")
    	end
    end)

----------------------------------------------------------
--EVENTTYPE - Message - "Respawn"
----------------------------------------------------------
--added in version 1.2
--this handles the respawn message
RegisterEventHandler(EventType.Message, "Respawn", 
    function()
    	if not(this:GetObjVar("sleeping")) then
    		if(this:GetObjVar("active")) then
	    		local mob_list = this:GetObjVar("mob_list")
	    		local templates = this:GetObjVar("templates")
	    		local min_range = this:GetObjVar("min_range")
	    		local max_range = this:GetObjVar("max_range")
				local spawn_mobile = ""
				local spawn_template = templates[this:GetObjVar("current_sequence")]
				local data = StringSplit(spawn_template,COMMAND_KEY)
				local spawn_mobile = data[1]
	    		for i = #mob_list, 1, -1 do
	    			GameObj(mob_list[i]):Destroy()
	    		end
				this:SetObjVar("count_current",0)
	    		this:SetObjVar("mob_list",{})    		
	    		for i = 1, this:GetObjVar("count_max") do
	    			if(this:GetObjVar("sequential") == true) then
	    				CreateObj(spawn_mobile,this:GetLoc():Project(math.random(0,360), math.random(min_range,max_range)),"mobileSpawned",1,spawn_template)
	    			else
	    				CreateObj(StringSplit(templates[math.random(1,#templates)],COMMAND_KEY)[1],this:GetLoc():Project(math.random(0,360), math.random(min_range,max_range)),"mobileSpawned",1,spawn_template)
	    			end
	    		end
    		end
    	end
    end)

----------------------------------------------------------
--EVENTTYPE - LoadedFromBackup - ""
----------------------------------------------------------
--added in version 1.2
--when i make updates to the spawner, i can use this
--to handle any changes that I need to add to the current
--spawns in the world.
RegisterEventHandler(EventType.LoadedFromBackup,"",SpawnerUpdate)

----------------------------------------------------------
--EVENTTYPE - Message - "activate"
----------------------------------------------------------
--this message is sent from the spawn_editor_menu
RegisterEventHandler(EventType.Message, "activate", 
    function()
    	if not(this:GetObjVar("active")) then
    		this:SetObjVar("active",true)
			this:ScheduleTimerDelay(TimeSpan.FromSeconds(GetRespawnDelay()), "spawnerTimer")
    	end
    end)

----------------------------------------------------------
--EVENTTYPE - Message - "deactivate"
----------------------------------------------------------
--this message is sent from the spawn_editor_menu
RegisterEventHandler(EventType.Message, "deactivate", 
    function()
	    if (this:GetObjVar("active")) then
    		this:SetObjVar("active",false)
    		this:SetObjVar("count_current",0)
    		this:SetObjVar("kill_count",0)
    		this:SetObjVar("current_sequence",0)
    		ShutDown()
    		CallFunctionDelayed(TimeSpan.FromMilliseconds(500),function ( ... )
			if(HasTooltipEntry(this,"is_being_edited")) then
				UpdateToolTip(this,true)
			else
				UpdateToolTip(this,false)
			end
    		end)
    	end    	
    end)

----------------------------------------------------------
--EVENTTYPE - CreatedObject - "mobileSpawned"
----------------------------------------------------------
--this even is fired when we successfuly create the spawned mobile
--it will attach a module and variable to the created mobile
RegisterEventHandler(EventType.CreatedObject, "mobileSpawned", 
	function(success, objref, index,spawn_template)
		if( success) then
			local current_count = this:GetObjVar("count_current")
			objref:SetObjVar("parentSpawner",this.Id)
			
			if not(objref:IsMobile() and objref:HasObjVar("ResourceSourceId")) then
				SetItemTooltip(objref)
			end

			current_count = current_count + 1
			this:SetObjVar("count_current",current_count)

			local mob_list = this:GetObjVar("mob_list")
			table.insert(mob_list,objref.Id)
			this:SetObjVar("mob_list",mob_list)

			HandleChanges(objref,spawn_template)
		end
		if(HasTooltipEntry(this,"is_being_edited")) then
			UpdateToolTip(this,true)
		else
			UpdateToolTip(this,false)
		end
	end)

----------------------------------------------------------
--EVENTTYPE - CreatedObject - "createdStackableLootOnMobile"
----------------------------------------------------------
--this takes care of items spawned with quantity
RegisterEventHandler(EventType.CreatedObject, "createdStackableLootOnMobile", 
	function(success,objRef,quantity)
		if( success == true ) then
			if( quantity ~= nil and quantity > 0 ) then			
				RequestSetStackCount(objRef,quantity)
			end
		end
	end)

----------------------------------------------------------
--EVENTTYPE - CreatedObject - "createdLootOnMobile"
----------------------------------------------------------
--this takes care of items spawned without quantity
RegisterEventHandler(EventType.CreatedObject, "createdLootOnMobile", 
	function(success, objref)
		if(type(quantity) == "number") then
			if(success and quantity > 1) then
				RequestSetStack(objRef,quantity)
			end
		end
		SetItemTooltip(objref)			
	end)

----------------------------------------------------------
--EVENTTYPE - DynamicWindowResponse - EditHueDialog
----------------------------------------------------------
--you can find the dialog window information in gizmos_spawner_hue_picker.lua
--the message is sent from the hue picker set button
RegisterEventHandler(EventType.DynamicWindowResponse,"EditHueDialog", 
	function (user,buttonId)
		if(buttonId ~= nil) then
			local items = StringSplit(buttonId,":")
			local action = items[1]
			local param = items[2]
			if(param ~= nil) then
				this:SetHue(param)
				user:SystemMessage("you have set the hue of the spawner")
			end
		end
	end)

----------------------------------------------------------
--EVENTTYPE - DynamicWindowResponse - EditLootTemplate
----------------------------------------------------------
--you can find the dialog window information in gizmos_spawner_edit_window.lua
--the message is sent from the edit window dialog response function
RegisterEventHandler(EventType.DynamicWindowResponse,"EditLootTemplate", 
	function (user,buttonId,textField)
		if(buttonId ~= nil) then
			local items = StringSplit(buttonId,":")
			local action = items[1]
			local param = items[2]
			if(action == "changeTemplateData") then
				local lootTemplate = {textField.edit_template_field,textField.edit_chance_field,textField.edit_quanitity_field}
				local templates = this:GetObjVar("loot")
				table.remove(templates,tonumber(param))
				table.insert(templates,tonumber(param),lootTemplate)
				this:SetObjVar("loot",templates)
				SimpleSpawnerEditWindow(user,this,"Loot")
			else
				user:SystemMessage("you decide not to change the loot template")
				SimpleSpawnerEditWindow(user,this,"Loot")
			end
		end
	end)

----------------------------------------------------------
--EVENTTYPE - DynamicWindowResponse - EditSpawnerDialog
----------------------------------------------------------
--you can find the dialog window information in gizmos_spawner_edit_window.lua
--the message is sent from the edit window dialog response function
RegisterEventHandler(EventType.DynamicWindowResponse,"EditTemplateEntry", 
	function (user,buttonId,textField)
		if(buttonId ~= nil) then
			local items = StringSplit(buttonId,":")
			local action = items[1]
			local param = items[2]
			if(action == "changeTemplateData") then
				local templates = this:GetObjVar("templates")
				--local unformattedtext = string.gsub(textField.edit_template_field,"\n","")
				table.remove(templates,tonumber(param))
				table.insert(templates,tonumber(param),textField.edit_template_field)
				this:SetObjVar("templates",templates)
				SimpleSpawnerEditWindow(user,this,"Spawns")
			else
				user:SystemMessage("you decide not to change the loot template")
				SimpleSpawnerEditWindow(user,this,"Spawns")
			end
		end
	end)

----------------------------------------------------------
--EVENTTYPE - DynamicWindowResponse - EditSpawnerDialog
----------------------------------------------------------
--you can find the dialog window information in gizmos_spawner_edit_window.lua
--the message is sent from the edit window dialog response function
RegisterEventHandler(EventType.DynamicWindowResponse,"EditSpawnerDialog", 
	function (user,buttonId,textField)
		if(buttonId ~= nil) then
			local items = StringSplit(buttonId,":")
			local action = items[1]
			local param = items[2]

			--the below code is what takes care of the tabbing system
			if(action == "Spawns") then SimpleSpawnerEditWindow(user,this,"Spawns") end
			if(action == "Config") then SimpleSpawnerEditWindow(user,this,"Config") end
			if(action == "Search") then SimpleSpawnerEditWindow(user,this,"Search") end
			if(action == "Loot") then SimpleSpawnerEditWindow(user,this,"Loot") end
			if(action == "Active") then SimpleSpawnerEditWindow(user,this,"Active") end

			if(action == "EditLootTemplate") then
				local window = DynamicWindow("EditLootTemplate","[BBBB44]Editing Loot Info",500,120,-300,-300,"NoFrame","Center")
				local templates = this:GetObjVar("loot")

				window:AddLabel(13,10,"Template",90,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
				window:AddTextField(85,8,390,20,"edit_template_field",templates[tonumber(param)][1])
				window:AddLabel(13,30,"Chance",90,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
				window:AddTextField(85,30,150,20,"edit_chance_field",templates[tonumber(param)][2])
				window:AddLabel(240,30,"Quntity",90,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
				window:AddTextField(305,30,170,20,"edit_quanitity_field",templates[tonumber(param)][3])
				window:AddButton(10,55,"changeTemplateData:"..param,"Save",230,28,"[FF7700]Save\n[FFFFBB]save the loot template data",nil,true,"SimpleButton")
				window:AddButton(240,55,"cancel","Cancel",230,28,"[FF7700]Cancel\n[FFFFBB]cancel editing the loot template data",nil,true,"SimpleButton")

				user:OpenDynamicWindow(window,this)

			end 

			if(action == "EditTemplateEntry") then
				local window = DynamicWindow("EditTemplateEntry","[BBBB44]Editing Template Info",500,500,-300,-300,"NoFrame","Center")
				local templates = this:GetObjVar("templates")

				-- local template_data = templates[tonumber(param)]
				-- local template_split = StringSplit(template_data,"@")
				-- local final_template = template_split[1]
				
				-- if(#template_split > 1) then
				-- 	for i = 2, #template_split do
				-- 		final_template = final_template .. "\n@" .. template_split[i]
				-- 	end
				-- end
				window:AddTextField(10,8,462,220,"edit_template_field",templates[tonumber(param)])

				window:AddButton(15,425,"changeTemplateData:"..param,"Save",230,28,"[FF7700]Save\n[FFFFBB]save the template data",nil,true,"SimpleButton")
				window:AddButton(240,425,"cancel","Cancel",230,28,"[FF7700]Cancel\n[FFFFBB]cancel editing the template data",nil,true,"SimpleButton")

				window:AddImage(550,0,"TextBoxBG",300,190,"Sliced",nil,0.7)

				user:OpenDynamicWindow(window,this)

			end			

			--the following section controls the spawner and allow you to 
			--turn off and on the spawner system.
			if(action == "Deactivate") then	
				this:SendMessage("deactivate")
				if(HasTooltipEntry(this,"is_being_edited")) then
					UpdateToolTip(this,true)
				else
					UpdateToolTip(this,false)
				end
				SimpleSpawnerEditWindow(user,this,"Config")
				user:SystemMessage("spawner deactivated and is now offline")
			end
			if(action == "Activate") then
				this:SendMessage("activate")
				if(HasTooltipEntry(this,"is_being_edited")) then
					UpdateToolTip(this,true)
				else
					UpdateToolTip(this,false)
				end
				SimpleSpawnerEditWindow(user,this,"Config")
				user:SystemMessage("spawner activated and is now online")
			end

			--version 1.3
			if(action == "Sleep") then
				this:SendMessage("Sleep")
			end
			if(action == "Wakeup") then
				this:SendMessage("Wakeup")
			end
			if(action == "Respawn") then
				this:SendMessage("Respawn")
			end						
			if(action == "SequentialOff") then
				this:SetObjVar("sequential",false)
				UpdateToolTip(this, true)
				SimpleSpawnerEditWindow(user,this,"Config")
				this:SendMessage("Respawn")
			end 
			if(action == "SequentialOn") then
				this:SetObjVar("sequential",true)
				UpdateToolTip(this, true)
				SimpleSpawnerEditWindow(user,this,"Config")
				this:SendMessage("Respawn")
			end			
			--this fires the script xml file function
			if(action == "CreateIt") then
				if(user:GetObjVar("ModName") ~= nil) then
					local file = io.open("mods/".. user:GetObjVar("ModName") .."/templates/spawners/junka.lua","w")
					if(file ~= nil) then
						local directory = "mods/".. user:GetObjVar("ModName") .."/templates/spawners/"
						local name, color = StripColorFromString(this:GetName())
						local name = name:lower()
						name = string.gsub(name,"- ","")
						name = string.gsub(name,"-","")
						name = string.gsub(name,"'","")
						local filename = string.gsub(name," ","_")
						if(filename=="gizmos_simple_spawner") then
							user:SystemMessage("[FF7700]Name Error")
							user:SystemMessage("[FFDD00]you can not save as gizmos_simple_spawner...rename your spawner in the config menu.")
							return
						end
						local fullpath = directory .. filename .. ".xml"
						CreateTemplate(fullpath,user)
					else
						user:SystemMessage("[FF7700]-------------------------------------------------")
						user:SystemMessage("[22FF22]                  -[SETUP REQUIRED]-")
						user:SystemMessage("[FF7700]-------------------------------------------------")
						user:SystemMessage("[22FF22]Simply Do The Following")
						user:SystemMessage("[FFFFBB]I see you completed step 1 by creating your ModName variable. One more step and we will be ready. Create a folder named [FF7700]'spawners' [FFFFBB] in your mods/"..user:GetObjVar("ModName").."/templates directory")
					end
				else
					user:SystemMessage("[FF7700]-------------------------------------------------")
					user:SystemMessage("[22FF22]                  -[SETUP REQUIRED]-")
					user:SystemMessage("[FF7700]-------------------------------------------------")
					user:SystemMessage("[22FF22]Simply Do The Following")
					user:SystemMessage("[FFFFBB]Add a string variable named [FF7700]'ModName'[FFFFBB] to your character. Name this variable the same name as your mod name, remember folders are case sensitive. This is so you can save these templates directly to your mod folder. These templates will be placed in the following directory [FF7700]'yourmod/templates/merchants'")
				end
			end
			--this is fired when you click the insert button in the Spawns tab
			if(action == "AddMobileToList") then
				if(textField.template_reference ~= "") then
					local list = this:GetObjVar("templates")
					table.insert(list,textField.template_reference)
					this:SetObjVar("templates",list)
					SimpleSpawnerEditWindow(user,this)
					user:SystemMessage("you have successfully added the mob to the spawn table")
				end
			end

			--this is fired when you click the [X] in the Spawns tab
			if(action == "DeleteMobFromList") then
				local list = this:GetObjVar("templates")
				table.remove(list,tonumber(param))
				this:SetObjVar("templates",list)
				SimpleSpawnerEditWindow(user,this)
				user:SystemMessage("you have successfully removed the mob from the spawn table")
			end

			--this is fired when you click the edit option in the
			--config menu. it will gather the information from the
			--text field and enter it into the spawners objvar.
			if(action == "EditConfig") then
				if(param == "min_delay") then this:SetObjVar("min_delay",tonumber(textField.prop_value_min_delay)) end
				if(param == "max_delay") then this:SetObjVar("max_delay",tonumber(textField.prop_value_max_delay)) end
				if(param == "min_range") then this:SetObjVar("min_range",tonumber(textField.prop_value_min_range)) end
				if(param == "max_range") then this:SetObjVar("max_range",tonumber(textField.prop_value_max_range)) end
				if(param == "count_max") then this:SetObjVar("count_max",tonumber(textField.prop_value_count_max)) end
				if(param == "spawner_tag") then this:SetObjVar("spawner_tag",textField.prop_value_spawner_tag) end

				UpdateConfig()
				UpdateToolTip(this,true)
				SimpleSpawnerEditWindow(user,this,"Config")
				user:SystemMessage("configuration sucessfully added to the spawner")
			end

			--this will delete a loot template from the loot table list
			if(action == "DeleteLootTemplate") then		
				local list = this:GetObjVar("loot")
				table.remove(list,tonumber(param))
				this:SetObjVar("loot",list)
				SimpleSpawnerEditWindow(user,this,"Loot")
				user:SystemMessage("item value successfully removed from the spawner")		
			end

			--this is fired when you click the insert button in the Loot tab
			if(action == "AddItemToList") then
				if(textField.item_reference ~= "") then
					local list = this:GetObjVar("loot")
					local data = StringSplit(textField.item_reference,":")
					local loot_table = {textField.loot_template,textField.loot_chance,textField.loot_quantity}
					local doinsert = true
					if(textField.loot_template == nil or textField.loot_chance == nil or textField.loot_quantity == nil) then
						doinsert = false
						user:SystemMessage("you entered bad data, try again")
					end
					if(doinsert) then
						table.insert(list,loot_table)
						this:SetObjVar("loot",list)
						user:SystemMessage("item values successfully added to the spawner")
					end
					SimpleSpawnerEditWindow(user,this,"Loot")
				end
			end

			--this is fired when you click home button on the active tab
			if(action == "SendHome") then
				local mob_list = this:GetObjVar("mob_list")						
				local mobile = GameObj(mob_list[tonumber(param)])
				mobile:SetWorldPosition(this:GetLoc())
				user:SystemMessage(mobile:GetName().." has be sent back home")
			end	

			--this is fired when you click the change name edit button in 
			--the spawner configu menu
			if(action == "ChangeName") then
				this:SetName("[CCCC00]"..textField.spawner_name_value)
				UpdateToolTip(this,true)
				user:SystemMessage("you have successfully changed the name of this spawner")
				SimpleSpawnerEditWindow(user,this,"Config")
			end

			--------------------------------------
			-- SEARCH FEATURE BUTTON CLICKS 
			--------------------------------------
			--CopyObjectToPos(...) see lua page for info

			--this is fired when you click Name button on the search tab
			if(action == "SearchName") then
				local queryString = textField.query_value
				if(queryString ~= nil) then
					SimpleSpawnerEditWindow(user,this,"Search","Name:"..queryString)
					user:SystemMessage("you are querying for spawners with a name including ['".. queryString .."']")
				end
			end

			--this is fired when you click template button on the search tab
			if(action == "SearchTemplate") then
				local queryString = textField.query_value
				if(queryString ~= nil) then
					SimpleSpawnerEditWindow(user,this,"Search","Template:"..queryString)
					user:SystemMessage("you are querying for spawners with a mobile template including ['".. queryString .."']")
				end
			end

			--this is fired when you click objectid button on the search tab
			if(action == "SearchObjectId") then
				local queryString = textField.query_value
				if(queryString ~= nil) then
					SimpleSpawnerEditWindow(user,this,"Search","Id:"..queryString)
					user:SystemMessage("you are querying for spawners with a object id including ['".. queryString .."']")
				end
			end

			--this is fired when you click objectid button on the search tab
			if(action == "SearchLootTemp") then
				local queryString = textField.query_value
				if(queryString ~= nil) then
					SimpleSpawnerEditWindow(user,this,"Search","LootTemplate:"..queryString)
					user:SystemMessage("you are querying for spawners with a loot item including ['".. queryString .."']")
				end
			end

			--this is fired when you click objvar button on the search tab
			if(action == "SearchObjVar") then
				local queryString = textField.query_value
				if(queryString ~= nil) then
					SimpleSpawnerEditWindow(user,this,"Search","ObjVar:"..queryString)
					user:SystemMessage("you are querying for spawners with a objvar including ['".. queryString .."']")
				end
			end

			--this is fired when you click tag button on the search tab
			if(action == "SearchTag") then
				local queryString = textField.query_value
				if(queryString ~= nil) then
					SimpleSpawnerEditWindow(user,this,"Search","Tag:"..queryString)
					user:SystemMessage("you are querying for spawners with a tag including ['".. queryString .."']")
				end
			end

			----------------------------------------
			-- SEARCH FEATURE QUERY BUTTON CLICKS 
			----------------------------------------	
			
			--this is fired when you click the Jump To button in the
			--search tab query field list
			if(action == "JumpToSearch") then
				local spawner = GameObj(tonumber(param))
				user:PlayEffect("TeleportToEffect")
				user:SetWorldPosition(spawner:GetLoc())
				user:PlayEffect("TeleportFromEffect")
				user:SystemMessage("you have been moved to the spawner")
			end	

			--this is fired when you click the Edit button in the
			--search tab query field list
			if(action == "EditSearch") then
				local spawner = GameObj(tonumber(param))
				SimpleSpawnerEditWindow(user,spawner)
				if(HasTooltipEntry("is_being_edited")) then
					RemoveTooltipEntry(this,"is_being_edited")
				end
				UpdateToolTip(spawner,true)
				user:SystemMessage("you are now editing the spawner '"..string.sub(spawner:GetName(),9).."'")
			end

			--this is fired when you click the Turn On/Turn Off button in the
			--search tab query field list
			if(action == "ActivateSearch") then
				local data = StringSplit(param,"|")
				local spawner = GameObj(tonumber(data[1]))
				if(spawner:GetObjVar("active")) then
					spawner:SetObjVar("active",false)
					user:SystemMessage("you have deactivated the spawner '"..string.sub(spawner:GetName(),9).."'")
				else
					spawner:SetObjVar("active",true)
					user:SystemMessage("you have activated the spawner '"..string.sub(spawner:GetName(),9).."'")
				end
				SimpleSpawnerEditWindow(user,this,"Search","Name:"..data[2])
				UpdateToolTip(spawner,true)
			end
		end
		if(buttonId == "") then
			UpdateToolTip(this,false)
		end
	end)

----------------------------------------------------------
--EVENTTYPE - Timer - "spawnTimer"
----------------------------------------------------------
--this is the defibrillator of the system. should
--be left alone unless you know what your doing
RegisterEventHandler(EventType.Timer, "spawnerTimer", 
	function()
		--SomeFunction(arg)
		if(this:GetObjVar("active")) then
			if not(this:GetObjVar("sequential")) then
				if(this:GetObjVar("count_current") < this:GetObjVar("count_max")) then
					SpawnObject()
				end
			else
				if not(this:HasObjVar("PhaseSpawned")) then
					SequentialSpawnObject()
				end
			end
		end
		--keep the timer kicking
		if(HasTooltipEntry(this,"is_being_edited")) then
			UpdateToolTip(this,true)
		else
			UpdateToolTip(this,false)
		end
		if(this:GetObjVar("active") == true) then
			this:ScheduleTimerDelay(TimeSpan.FromSeconds(GetRespawnDelay()), "spawnerTimer")
		end
	end)

